/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 * 
 *  DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 *  This code is free software; you can redistribute it and/or modify it
 *  under the terms of the GNU General Public License version 3, 
 *  or (at your option) any later version, as published by the Free Software Foundation.  
 *  The authors designate this particular file as subject to the "Classpath" exception 
 *  as provided in the LICENSE file that accompanied this code.
 *
 *  This code is distributed in the hope that it will be useful, but WITHOUT
 *  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 *  FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 *  version 3 for more details (a copy is included in the LICENSE file that
 *  accompanied this code).
 *
 *  You should have received a copy of the GNU General Public License version 3
 *  along with this work; if not, see http://www.gnu.org/licenses/gpl-3.0.txt 
 *
 *  Please contact visnow.org or visit www.visnow.org if you need additional information or
 *  have any questions.
 *
 */

package org.visnow.vn.lib.basic.filters.IntensityEqualizer;

import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import org.visnow.vn.engine.core.ParameterProxy;
import org.visnow.vn.engine.core.Parameters;
import static org.visnow.vn.lib.basic.filters.IntensityEqualizer.IntensityEqualizerShared.WEIGHTS;

/**
 *
 * @author babor
 */
public class WeightUI extends javax.swing.JPanel
{
    private Parameters parameters;
    private ChangeListener statusListener = null;

    /**
     * Creates new form WeightUI
     */
    public WeightUI()
    {
        initComponents();
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        weightSlider = new org.visnow.vn.gui.widgets.FloatSlider();
        resetButton = new javax.swing.JButton();

        setMinimumSize(new java.awt.Dimension(200, 60));
        setPreferredSize(new java.awt.Dimension(200, 60));
        setLayout(new java.awt.GridBagLayout());

        weightSlider.setBorder(javax.swing.BorderFactory.createTitledBorder("weight"));
        weightSlider.setMax(2.0F);
        weightSlider.setMin(-2.0F);
        weightSlider.setName("weightSlider"); // NOI18N
        weightSlider.setShowingFields(false);
        weightSlider.setVal(1.0F);
        weightSlider.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                weightSliderStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.NORTHWEST;
        gridBagConstraints.weightx = 1.0;
        gridBagConstraints.weighty = 1.0;
        add(weightSlider, gridBagConstraints);

        resetButton.setIcon(new javax.swing.ImageIcon(getClass().getResource("/org/visnow/vn/gui/icons/reset.png"))); // NOI18N
        resetButton.setMargin(new java.awt.Insets(0, 0, 0, 0));
        resetButton.setMaximumSize(new java.awt.Dimension(18, 18));
        resetButton.setMinimumSize(new java.awt.Dimension(18, 18));
        resetButton.setName("resetButton"); // NOI18N
        resetButton.setPreferredSize(new java.awt.Dimension(18, 18));
        resetButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                resetButtonActionPerformed(evt);
            }
        });
        add(resetButton, new java.awt.GridBagConstraints());
    }// </editor-fold>//GEN-END:initComponents

    private void weightSliderStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_weightSliderStateChanged
        if (!weightSlider.isAdjusting()) {
            float[] weights = parameters.get(WEIGHTS);
            weights[weightIndex] = weightSlider.getVal();
            parameters.set(WEIGHTS, weights);
            fireStateChange();
        }
    }//GEN-LAST:event_weightSliderStateChanged

    private void resetButtonActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_resetButtonActionPerformed
    {//GEN-HEADEREND:event_resetButtonActionPerformed
        weightSlider.setVal(1.0f);
        float[] weights = parameters.get(WEIGHTS);
        weights[weightIndex] = 1.0f;
        parameters.set(WEIGHTS, weights);
        fireStateChange();
    }//GEN-LAST:event_resetButtonActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton resetButton;
    private org.visnow.vn.gui.widgets.FloatSlider weightSlider;
    // End of variables declaration//GEN-END:variables

    private int weightIndex = 0;

    public void setParameters(Parameters parameters)
    {
        this.parameters = parameters;
    }

    public void setWeightIndex(int n)
    {
        this.weightIndex = n;
        weightSlider.setBorder(javax.swing.BorderFactory.createTitledBorder("Level " + n + " weight"));
    }

    public void updateGUI(ParameterProxy p)
    {
        weightSlider.setEnabled(true);
        weightSlider.setVal(p.get(WEIGHTS)[weightIndex]);//params.getWeight(this.weightIndex));
    }

    public void addChangeListener(ChangeListener listener)
    {
        if (statusListener == null)
            this.statusListener = listener;
        else
            System.out.println("" + this + ": only one status listener can be added");
    }

    private void fireStateChange()
    {
        ChangeEvent e = new ChangeEvent(this);
        if (statusListener != null)
            statusListener.stateChanged(e);
    }

}
